"use strict";

var childProcess = require("child_process");
var cut_file = require("./random_gen").cut_file;
var diskspace = require("diskspace");
// var os_utils = require("os-utils");
var os = require('os');
const puppeteer = require("puppeteer");
const Server = require("ws").Server;
const args = require("yargs")
.usage("Usage : load_content.js -file file_path")
.demandOption(["file"])
.alias("f", "file")
.alias("l", "link")
.describe("file", "file containing content, data must follow the CSV standard")
.describe("link", "link to website treating the data, defaults to Mynij")
.nargs("file", 1)
.nargs("link", 1)
.argv;

var link = args.link
? args.link
: "https://softinst115787.host.vifib.net/public/unit_tests/index_load.html";

var files;
var browser;
var page;
var n = 0;
var time;
var monitor;
var ramBefore;
var memBefore;

function init_server (){
    var port = 9030;
    var ws = new Server({port: port});
    ws.on("connection", function(w){
        w.on("message", function(){
            process.send(n + "," + Date.now());
            query();
        });
        w.on("close", function() {
            ws.close();
        });
    });
}

function timeout (){
    //Every 30 minutes, check if more than 2 hours have passed since last response
    setTimeout(function () {
        if (Date.now() - time > 7200000){ //2 hours
            process.send(n + ",Timeout error \n");
            files = [];
            query();
        } else {
            timeout();
        }
    }, 1800000); //30 minutes
}

async function query (){
    if (files.length === 0){
        monitor.kill();
        var ipc=require("node-ipc");
        ipc.config.silent = true;
        ipc.connectTo("main");
        ipc.of.main.emit("message", "DONE");
        return;
    } else {
        n += 1000;
        time = Date.now();
        // monitor = childProcess.fork("./unit_tests/monitor.js");
        // monitor.on("message", function(msg){
        //     diskspace.check("C", function (err, result){
        //         var memUsed = (result.used/1024/1024) - memBefore;
        //         var ramUsed = parseInt(msg) - ramBefore;
        //         console.log(ramUsed/1024/1024);
        //         //process.send(n + "," + ramUsed + "," + memUsed + "\n");
        //         monitor.kill();
        //         query();
        //     });
        // });
        const [fileChooser] = await Promise.all([
            page.waitForFileChooser(),
            page.click("input#load")
        ]);
        await fileChooser.accept([files.shift()]);
    }
}

(async () => {
    files = cut_file(args.file, 1000);
    init_server();
    browser = await puppeteer.launch();
    page = await browser.newPage();
    await page.goto(link);
    monitor = childProcess.fork("./unit_tests/monitor.js",
        args.r ? ["-r"] : []);
    timeout();
    query();
    // diskspace.check("C", function (err, result){
    //     memBefore = result.used/1024/1024;
    //     timeout();
    //     query();
    // });
})();
