const puppeteer = require("puppeteer");
const Server = require("ws").Server;
const args = require("yargs")
    .usage("Usage : add_rss.js -file file_path")
    .demandOption(["file"])
    .alias("f", "file")
    .describe("file", "path to the RSS File")
    .nargs("file", 1)
    .alias("l", "link")
    .describe("link", "link to website treating the data, defaults to Mynij")
    .nargs("link", 1)
    .argv;

var link = args.link
    ? args.link
    : "https://softinst115787.host.vifib.net/public/unit_tests/add_rss.html";

var browser;
var index_start;
var index_total;
var db_start;
var db_total;

function init_server (){
    var ws = new Server({port: 9030});
    ws.on("connection", function(w){
        w.on("message", function(msg){
            if (msg === "Index"){
                index_start = Date.now();
            } else if (msg === "Database"){
                index_total = Date.now() - index_start;
                db_start = Date.now();
            } else if (msg.includes("Done")){
                db_total = Date.now() - db_start;
                process.send((db_total+index_total)/1000);
                process.send("DONE");
                ws.close();
                browser.close();
            } else {
                process.send(msg);
                ws.close();
                browser.close();
            }
        });
        w.on("close", function() {
            ws.close();
        });
    });
}

(async () => {
    init_server();
    browser = await puppeteer.launch();
    var page = await browser.newPage();
    await page.goto(link);
    const [fileChooser] = await Promise.all([
        page.waitForFileChooser(),
        page.click("input#load")
    ]);
    await fileChooser.accept([args.file]);
})();
