const puppeteer = require("puppeteer");
const Server = require("ws").Server;
const args = require("yargs")
    .usage("Usage : add_sitemap.js -file file_path")
    .demandOption(["file"])
    .alias("f", "file")
    .describe("file", "path to the Sitemap XML File")
    .nargs("file", 1)
    .alias("l", "link")
    .describe("link", "link to website treating the data, defaults to Mynij")
    .nargs("link", 1)
    .argv;

var link = args.link
    ? args.link
    : "https://softinst115787.host.vifib.net/public/unit_tests/add_sitemap.html";

var browser,
    start;

function init_server (){
    var port = 9030;
    var ws = new Server({port: port});
    ws.on("connection", function(w){
        w.on("message", function(msg){
            if (msg.includes("Done")){
                var now = Date.now();
                process.send((now-start)/1000);
                process.send("DONE");
                ws.close();
                browser.close();
            } else {
                console.log(msg);
                ws.close();
                browser.close();
            }
        });
        w.on("close", function() {
            ws.close();
        });
    });
}

(async () => {
    init_server();
    browser = await puppeteer.launch();
    var page = await browser.newPage();
    await page.goto(link);
    start = Date.now();
    const [fileChooser] = await Promise.all([
        page.waitForFileChooser(),
        page.click("input#load")
    ]);
    await fileChooser.accept([args.file]);
})();
