"use strict";

var cut_file = require("./random_gen").cut_file;
const puppeteer = require("puppeteer");
const Server = require("ws").Server;
const args = require("yargs")
    .usage("Usage : download_index.js -file file_path")
    .demandOption(["file"])
    .alias("f", "file")
    .alias("l", "link")
    .describe("link", "link to website treating the data, defaults to Mynij")
    .describe("file", "file containing content, data must follow the CSV standard")
    .nargs("file", 1)
    .nargs("link", 1)
    .argv;

var link = args.link
    ? args.link
    : "https://softinst115787.host.vifib.net/public/unit_tests/" +
                    "download_index.html";

var browser;
var start;
var n = 0;
var time;
var page;
var files;

function init_server (){
    var port = 9030;
    var ws = new Server({port: port});
    ws.on("connection", function(w){
        w.on("message", function(msg){
            if (msg === "Start"){
                start = Date.now();
            } else if (msg === "Done"){
                var total = Date.now() - start;
                process.send(total/1000);
                process.send("DONE");
            } else {
                console.log("Error : " + msg);
                browser.close();
            }
        });
        w.on("close", function() {
            ws.close();
        });
    });
}

function timeout (){
    setTimeout(function () {
        if (Date.now() - time > 7200000){ //2 hours
            process.send(n + ",Timeout error \n");
            files = [];
            query();
        } else {
            timeout();
        }
    }, 1800000); //30 minutes
}

async function query (){
    if (files.length === 0){
        var ipc=require("node-ipc");
        ipc.config.silent = true;
        ipc.connectTo("main");
        ipc.of.main.emit("message", "DONE");
        return;
    } else {
        n += 1000;
        time = Date.now();
        const [fileChooser] = await Promise.all([
            page.waitForFileChooser(),
            page.click("input#load")
        ]);
        await fileChooser.accept([files.shift()]);
    }
}

(async () => {
    files = cut_file(args.file, 1000);
    init_server();
    browser = await puppeteer.launch({headless: false});
    page = await browser.newPage();
    await page.goto(link);
    timeout();
    query();
})();
