const puppeteer = require("puppeteer");
const Server = require("ws").Server;
const args = require("yargs")
    .usage("Usage : export_index.js -file file_path")
    .demandOption(["file"])
    .alias("f", "file")
    .describe("file", "file containing content, data must follow JSON standard")
    .nargs("file", 1)
    .alias("l", "link")
    .describe("link", "link to website treating the data, defaults to Mynij")
    .nargs("link", 1)
    .argv;

var link = args.link
    ? args.link
    : "https://softinst115787.host.vifib.net/public/unit_tests/" +
"export_index.html";

var browser;
var start;
var zip;
var plain_start;
var plain;

function init_server (){
    var port = 9030;
    var ws = new Server({port: port});
    ws.on("connection", function(w){
        w.on("message", function(msg){
            if (msg === "Start"){
                start = Date.now();
            } else if (msg === "Zip"){
                zip = Date.now() - start;
                plain_start = Date.now();
            } else if (msg === "JSON"){
                plain = Date.now() - plain_start;
                process.send(zip/1000 + "," +plain/1000);
                process.send("DONE");
                ws.close();
                browser.close();
            } else {
                console.log("Error : " + msg);
                browser.close();
            }
        });
        w.on("close", function() {
            ws.close();
        });
    });
}

(async () => {
    init_server();
    browser = await puppeteer.launch();
    var page = await browser.newPage();
    await page.goto(link);
    const [fileChooser] = await Promise.all([
        page.waitForFileChooser(),
        page.click("input#load")
    ]);
    await fileChooser.accept([args.file]);
})();
